//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <math.h>
#pragma hdrstop

#include "DskCrunchDlgs.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TDskCrunchDlg *DskCrunchDlg;
unsigned __int64 reserved = 102400;
//---------------------------------------------------------------------------
bool __fastcall CheckDiskSpace(TForm *Owner, AnsiString diskpath, unsigned __int64 datspace)
{
   unsigned __int64 dskspace = DiskFreeSpace(diskpath);
   if (ShowDiskSpaceError(Owner,diskpath,(int)dskspace)) return false;
   dskspace = dskspace>reserved ? dskspace-reserved:0;
   if (dskspace>datspace) return true;
   DskCrunchDlg = new TDskCrunchDlg(Owner);
   DskCrunchDlg->datspace = datspace;
   DskCrunchDlg->diskpath = diskpath;
   DskCrunchDlg->ShowModal();
   bool ok = DskCrunchDlg->ModalResult==mrOk;
   delete DskCrunchDlg;
   return ok;
}
//---------------------------------------------------------------------------
unsigned __int64 __fastcall DiskFreeSpace(AnsiString diskpath)
{
   DWORD spc,bps,nfc,tnc;
   OSVERSIONINFO verinfo;
   unsigned __int64	BAC,TNB;//,TNFB;
   verinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
   if (GetVersionEx(&verinfo))
   {
      switch (verinfo.dwPlatformId)
      {
         case VER_PLATFORM_WIN32_WINDOWS:
            if (LOWORD(verinfo.dwBuildNumber)<=1000)
            {
               if (!GetDiskFreeSpace(diskpath.c_str(),&spc,&bps,&nfc,&tnc))
               {
                  return -1;
               }
               return (nfc*bps*spc);
            }
         case VER_PLATFORM_WIN32_NT:
            if (!GetDiskFreeSpaceEx(diskpath.c_str(),(ULARGE_INTEGER*)&BAC,(ULARGE_INTEGER*)&TNB,NULL))
            {
               return -2;
            }
            return BAC;
      }
   }
   return -3;
}
//---------------------------------------------------------------------------
bool __fastcall ShowDiskSpaceError(TForm *Owner, AnsiString diskpath, int errnum)
{
   switch (errnum)
   {
      case -1:
         MsgBoxHwnd(Owner->Handle,
            s("Unable to get disk free space for drive: "+diskpath+"\n")+
            s( GetLastErrorStr()),"ERROR",MB_OK);
         return true;
      case -2:
         MsgBoxHwnd(Owner->Handle,
            s("Unable to get disk free space for drive: "+diskpath+"\n")+
            s( GetLastErrorStr()),"ERROR",MB_OK);
         return true;
      case -3:
         MsgBoxHwnd(Owner->Handle,
            s("Unable to get disk free space for drive: "+diskpath+"\n")+
            s("Unlisted Platform ID"),"ERROR",MB_OK);
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CommaUI64Number(unsigned __int64 number)
{
   char *numbuf; numbuf = new char[64];
   _ui64toa(number,numbuf,10);
   AnsiString commanum,num(numbuf);
   delete numbuf;
 //num = "78364269707876986463278067844535";
   int c=0; for (int i=num.Length(); i>0; i--)
   {
      if (c>2 && fmod(c,3)==0) commanum = "," + commanum;
      commanum = s(num[i]) + commanum;
      c++;
   }
   return commanum;
}
//---------------------------------------------------------------------------
__fastcall TDskCrunchDlg::TDskCrunchDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
}
//---------------------------------------------------------------------------
void __fastcall TDskCrunchDlg::SetDlgText()
{
   Label1->Caption =
      s("Your data cannot be saved! Space required is "+CommaUI64Number(datspace)+" bytes, but ")+
      s("there are only "+CommaUI64Number(dskspace)+" bytes free disk space available. Please ")+
      s("delete some files and try again, or cancel to terminate this process and return to QS ")+
      s("without saving.");
}
//---------------------------------------------------------------------------
void __fastcall TDskCrunchDlg::FormShow(TObject *Sender)
{
   dskspace = DiskFreeSpace(diskpath);
   if (dskspace>0) dskspace -= reserved;
   SetDlgText();
}
//---------------------------------------------------------------------------
void __fastcall TDskCrunchDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrRetry)
   {
      dskspace = DiskFreeSpace(diskpath)-reserved;
      AnsiString cap = Caption; Caption = "Checking...";
      Label1->Caption = ""; AppProcessMessages(); Sleep(500);
      if (dskspace<datspace)
      {
         CanClose = false;
         Caption = cap;
         SetDlgText();
         return;
      }
      Caption = cap;
      MsgBoxHwnd(Handle,"Great! We have the needed disk space!","Success",MB_OK);
      AppProcessMessages(); Sleep(100);
      ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
