//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MimeDecDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma link "MimeDec"
#pragma resource "*.dfm"
TMimeDecDlg *MimeDecDlg;
//---------------------------------------------------------------------------
bool __fastcall ProcessMIMEmessage(TForm *Owner, TStream *msg)
{
   MimeDecDlg = new TMimeDecDlg(Owner);
   bool ok = MimeDecDlg->Execute(msg);
   delete MimeDecDlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall IsMIMEmessage(TStream *Msg)
{
   return true;
}
//---------------------------------------------------------------------------
__fastcall TMimeDecDlg::TMimeDecDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   message = new TStringList();
   html = new TStringList();
   hasplaintext = false;
   outfile = NULL;
}
//---------------------------------------------------------------------------
__fastcall TMimeDecDlg::~TMimeDecDlg()
{
   delete html;
   delete message;
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::Execute(TStream *Msg)
{
   Timer1->Enabled = true; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   MimeDec->DecodeStream(msg);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecHeaderLine(TObject *Sender)
{
   message->Add(MimeDec->CurrentData);
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecHeaderEnd(TObject *Sender)
{
   message->Add("");
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::IsAttachment()
{
   return MimeDec->PartDisposition.LowerCase()=="attachment";
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::IsInline()
{
   return MimeDec->PartDisposition.LowerCase()=="inline";
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::IsText()
{
   return MimeDec->PartContentType=="text/plain";
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::IsHtml()
{
   return MimeDec->PartContentType=="text/html";
}
//---------------------------------------------------------------------------
AnsiString __fastcall SoleExisting(AnsiString filename)
{
   int next=1;
   AnsiString ooos,orgname=filename,orgext=ExtractFileExt(orgname);
   while (FileExists(filename))
   {
      ooos = s(next++);
      while (ooos.Length()<4) ooos = "0"+ooos;
      filename = orgname.SubString(1,orgname.Length()-orgext.Length())+ooos+orgext;
   }
   return filename;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMimeDecDlg::GoodFilename(AnsiString filename)
{
   if (filename.IsEmpty()) filename = MimeDec->PartFileName;
   if (filename.IsEmpty()) filename = MimeDec->PartName;
   if (filename.IsEmpty()) filename = "Attachment";
   for (int i=1; i<filename.Length(); i++)
   {
      if (s("<>:/\|\"").Pos(filename[i])) filename[i] = '_'; else
      if ((BYTE)filename[i]<=30) filename[i] = '_';
   }
   return SoleExisting(AttachmentDir+filename);
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecPartBegin(TObject *Sender)
{
   if (IsAttachment())
   {
      CurFilename = GoodFilename("");
      outfile = new TFileStream(CurFilename,fmOpenWrite);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecPartLine(TObject *Sender, PChar Data,
	int DataLen)
{
   if (IsAttachment() || IsInline()) outfile->Write(Data,lstrlen(Data)); else
   if (IsText()) message->Add(Data); else
   if (IsHtml()) html->Add(Data);
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecPartEnd(TObject *Sender)
{
   if (IsAttachment())
   {
      message->Add("********Attachment saved: "+CurFilename);
      delete outfile;
      return;
   }
   if (IsHtml())
   {
      if (MimeDec->ContentType!="multipart/alternative")
      {
         int size;
         // load html into memory stream
         TMemoryStream *ms = new TMemoryStream();
         ms->SetSize(size=html->Text.Length());
         ms->Write(html->Text.c_str(),size);
         ms->Seek(0,soFromBeginning);
         // create richedit on the fly
         TRichEdit *re = new TRichEdit((void*)NULL);
         re->WordWrap = false;
         re->Visible = false;
         re->Parent = this;
         // load richedit from stream then get lines as plaintext
         re->Lines->LoadFromStream(ms);
         re->PlainText = true;
         html->Text = re->Lines->Text;
         delete re;
         // add results to message
         message->AddStrings(html);
         message->Add("");
      }
      html->Clear();
      return;
   }
   if (IsText())
   {
      hasplaintext = true;
      message->Add("");
   }
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecInlineDecodeBegin(TObject *Sender,
	AnsiString Filename)
{
   CurFilename = GoodFilename(Filename);
   outfile = new TFileStream(CurFilename,fmOpenWrite);
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecInlineDecodeLine(TObject *Sender,
	PChar Line)
{
   outfile->Write(Line,lstrlen(Line));
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::MimeDecInlineDecodeEnd(TObject *Sender,
	AnsiString Filename)
{
   message->Add("********Inline attachment saved: "+CurFilename);
   delete outfile;
}
//---------------------------------------------------------------------------
